#this file gets all the datasets used, and make it so that every dataset uses the same format for the data.
#it allso compiles all the c++ files that will be used with the TMB package.
AllData = T
if(AllData){
  setwd("C:/NTNU/Master/PL")
  #including all the data-sets
  pl_1920=read.csv("season-1920_csv.csv")
  pl_1920$Date = gsub(" ","",paste(substr(pl_1920$Date,1,6),substr(pl_1920$Date,9,10)))
  pl_2021 = read.csv("season-2021_csv.csv")
  pl_2021$Date = gsub(" ","",paste(substr(pl_2021$Date,1,6),substr(pl_2021$Date,9,10)))
  pl_1819 = read.csv("season-1819_csv.csv")
  pl_1819$Date = gsub(" ","",paste(substr(pl_1819$Date,1,6),substr(pl_1819$Date,9,10)))
  pl_1718 = read.csv("season-1718_csv.csv")
  pl_1617 = read.csv("season-1617_csv.csv")
  pl_1516 = read.csv("season-1516_csv.csv")
  pl_1415 = read.csv("season-1415_csv.csv")
  pl_1314 = read.csv("season-1314_csv.csv")
  pl_1213 = read.csv("season-1213_csv.csv")
  pl_1112 = read.csv("season-1112_csv.csv")
  pl_1011 = read.csv("season-1011_csv.csv")
  pl_0910 = read.csv("season-0910_csv.csv")
  pl_0910$Date =gsub(" ","",paste(substr(pl_0910$Date,9,10),"/",substr(pl_0910$Date,6,7),"/",substr(pl_0910$Date,3,4))) 
  
  EPL = data.frame(
    FTHG = c(pl_0910$FTHG,pl_1011$FTHG,pl_1112$FTHG,pl_1213$FTHG,pl_1314$FTHG,pl_1415$FTHG,pl_1516$FTHG,pl_1617$FTHG,pl_1718$FTHG,pl_1819$FTHG,pl_1920$FTHG,pl_2021$FTHG),
    FTAG = c(pl_0910$FTAG,pl_1011$FTAG,pl_1112$FTAG,pl_1213$FTAG,pl_1314$FTAG,pl_1415$FTAG,pl_1516$FTAG,pl_1617$FTAG,pl_1718$FTAG,pl_1819$FTAG,pl_1920$FTAG,pl_2021$FTAG),
    HomeTeam = c(pl_0910$HomeTeam,pl_1011$HomeTeam,pl_1112$HomeTeam,pl_1213$HomeTeam,pl_1314$HomeTeam,
                 pl_1415$HomeTeam,pl_1516$HomeTeam,pl_1617$HomeTeam,pl_1718$HomeTeam,pl_1819$HomeTeam,pl_1920$HomeTeam,pl_2021$HomeTeam),
    AwayTeam = c(pl_0910$AwayTeam,pl_1011$AwayTeam,pl_1112$AwayTeam,pl_1213$AwayTeam,pl_1314$AwayTeam,
                 pl_1415$AwayTeam,pl_1516$AwayTeam,pl_1617$AwayTeam,pl_1718$AwayTeam,pl_1819$AwayTeam,pl_1920$AwayTeam,pl_2021$AwayTeam),
    Date = c(pl_0910$Date,pl_1011$Date,pl_1112$Date,pl_1213$Date,pl_1314$Date,pl_1415$Date,pl_1516$Date,pl_1617$Date,pl_1718$Date,pl_1819$Date,pl_1920$Date,pl_2021$Date),
    FTR=c(pl_0910$FTR,pl_1011$FTR,pl_1112$FTR,pl_1213$FTR,pl_1314$FTR,pl_1415$FTR,pl_1516$FTR,pl_1617$FTR,pl_1718$FTR,pl_1819$FTR,pl_1920$FTR,pl_2021$FTR),
    B365H = c(pl_0910$B365H,pl_1011$B365H,pl_1112$B365H,pl_1213$B365H,pl_1314$B365H,pl_1415$B365H,pl_1516$B365H,pl_1617$B365H,pl_1718$B365H,pl_1819$B365H,pl_1920$B365H,pl_2021$B365H),
    B365D = c(pl_0910$B365D,pl_1011$B365D,pl_1112$B365D,pl_1213$B365D,pl_1314$B365D,pl_1415$B365D,pl_1516$B365D,pl_1617$B365D,pl_1718$B365D,pl_1819$B365D,pl_1920$B365D,pl_2021$B365D),
    B365A = c(pl_0910$B365A,pl_1011$B365A,pl_1112$B365A,pl_1213$B365A,pl_1314$B365A,pl_1415$B365A,pl_1516$B365A,pl_1617$B365A,pl_1718$B365A,pl_1819$B365A,pl_1920$B365A,pl_2021$B365A))

  NeedCompile = T#if one needs to compile the files, this is only nessesary once every restart of R. It will take some time
  if(NeedCompile){
    compile("binormalintercept.cpp")
    dyn.load(dynlib("binormalintercept"))
    compile("BNIrho.cpp")
    dyn.load(dynlib("BNIrho"))
    compile("GP.cpp")
    dyn.load(dynlib("GP"))
    compile("multinomRI.cpp")
    dyn.load(dynlib("multinomRI"))
    compile("HLC0.cpp")
    compile("HLCA.cpp")
    compile("HLC2.cpp")
    dyn.load(dynlib("HLCA"))
    dyn.load(dynlib("HLC0"))
    dyn.load(dynlib("HLC2"))
    compile("FullModelConst.cpp")
    dyn.load(dynlib("FullModelConst"))
    compile("FullModelTauCh.cpp")
    dyn.load(dynlib("FullModelTauCh"))
    compile("FullModelTau.cpp")
    dyn.load(dynlib("FullModelTau"))
    compile("FullModelCh.cpp")
    dyn.load(dynlib("FullModelCh"))
    compile("FullModel.cpp")
    dyn.load(dynlib("FullModel"))
    compile("multinomRW.cpp")
    dyn.load(dynlib("multinomRW"))
    compile("FullGP.cpp")
    dyn.load("FullGP")
  }
  #incomplete final line warnings can be ignored
  }
