#this file will include all that is important for the generalized poisson model.



season = 1112# assigning what seasons you would like to study
sesong = as.character(season)
PL = eval(as.symbol(paste0("pl_",season))) # assigning what seasons you would like to study
M = 19#the number of rounds after round 19. This was mainly a nesesaty when the current season(20/21) was not finished yet

teams = levels(as.factor(PL$HomeTeam))
x = PL$FTHG
y = PL$FTAG
HA = HomeAway(PL)
home = as.factor(HA[,1]-1)
away = as.factor(HA[,2]-1)
N = nlevels(home)
data = list(x=x,y=y,home=home,away=away,N=N)
parameters = list(c=0.1,ch=0.1,a=rep(0,N),d = rep(0,N),log_sd=c(-1,-1),delta=0)
random = c("a","d")
obj <- MakeADFun(data=data,parameters=parameters,random = random,DLL = "GP", silent = TRUE)
resGP <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repGP = sdreport(obj)
parameters = list(c=0.1,ch=0.1,a=rep(0,N),d = rep(0,N),log_sd=c(-1,-1))
obj <- MakeADFun(data=data,parameters=parameters,random = random,DLL = "binormalintercept", silent = TRUE)
resBI <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repBI = sdreport(obj)

d = -2*(resGP$value-resBI$value)
1-pchisq(d,1)#p-value for just one season at a time

#for all seasons at the same time 
HA09 = HomeAway(pl_0910)
HA10 = HomeAway(pl_1011)
HA11 = HomeAway(pl_1112)
HA12 = HomeAway(pl_1213)
HA13 = HomeAway(pl_1314)
HA14 = HomeAway(pl_1415)
HA15 = HomeAway(pl_1516)
HA16 = HomeAway(pl_1617)
HA17 = HomeAway(pl_1718)
HA18 = HomeAway(pl_1819)
HA19 = HomeAway(pl_1920)
HA20 = HomeAway(pl_2021)

home = c(HA09[,1],20+HA10[,1],40+HA11[,1],60+HA12[,1],80+HA13[,1],100+HA14[,1],120+HA15[,1],140+HA16[,1],160+HA17[,1],180+HA18[,1],200+HA19[,1],220+HA20[,1])
away = c(HA09[,2],20+HA10[,2],40+HA11[,2],60+HA12[,2],80+HA13[,2],100+HA14[,2],120+HA15[,2],140+HA16[,2],160+HA17[,2],180+HA18[,2],200+HA19[,2],220+HA20[,2])
home = as.factor(home-1)
away = as.factor(away-1)

x = c(pl_0910$FTHG,pl_1011$FTHG,pl_1112$FTHG,pl_1213$FTHG,pl_1314$FTHG,pl_1415$FTHG,pl_1516$FTHG,pl_1617$FTHG,pl_1718$FTHG,pl_1819$FTHG,pl_1920$FTHG,pl_2021$FTHG)
y = c(pl_0910$FTAG,pl_1011$FTAG,pl_1112$FTAG,pl_1213$FTAG,pl_1314$FTAG,pl_1415$FTAG,pl_1516$FTAG,pl_1617$FTAG,pl_1718$FTAG,pl_1819$FTAG,pl_1920$FTAG,pl_2021$FTAG)



data = list(x=x,y=y,home=home,away=away,N=nlevels(home))

parameters = list(log_sd = c(-1,-1),
                  a=rep(0,nlevels(home)),d=rep(0,nlevels(home)),c=0.5,ch=0.5,delta = 0)

random = c("a","d")

obj <- MakeADFun(data=data,parameters=parameters,random = random,DLL = "GP", silent = TRUE)
resGP <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repGP = sdreport(obj)
repGP


data = list(x=x,y=y,home=home,away=away,N=nlevels(home))

parameters = list(log_sd = c(0.1,0.1),
                  a=rep(0,nlevels(home)),d=rep(0,nlevels(home)),c=0.5,ch=0.5)

random = c("a","d")

obj <- MakeADFun(data=data,parameters=parameters,random = random,DLL = "binormalintercept", silent = TRUE)
resBI <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repBI = sdreport(obj)
repBI

d = 2*(resBI$value-resGP$value)
1-pchisq(d,1)#p-value for all seasons at the same time, this is significant

##########################################################

x = EPL$FTHG
y = EPL$FTAG
teams = levels(as.factor(EPL$HomeTeam))
HA = HomeAwayFull(EPL,teams)
home = as.factor(HA[,1]-1)
away = as.factor(HA[,2]-1)
m = matchNumber(EPL,teams)
mh = as.factor(m[,1])
ma = as.factor(m[,2])
n = max(m)+1
DT = makeDTfull(EPL,teams,n)
N = n-1
nt = length(teams)

data = list(x=x,y=y,home=home,away=away,mh=mh,ma=ma,DT=sqrt(DT),N=N,nt=nt)
parameters = list(a0=rep(0,nt),d0=rep(0,nt),a=matrix(0,ncol = N,nrow = nt),d=matrix(0,ncol = N,nrow = nt),log_sd=rep(-1,2),
                  tau=55,c=1,ch=1,delta=0)
random = c("a0","d0","a","d")

obj <- MakeADFun(data=data,parameters=parameters,random = random,DLL = "FullGP", silent = TRUE)
resGP <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repGP = sdreport(obj)
repGP

data = list(x=x,y=y,home=home,away=away,mh=mh,ma=ma,DT=sqrt(DT),N=N,nt=nt)
parameters = list(a0=rep(0,nt),d0=rep(0,nt),a=matrix(0,ncol = N,nrow = nt),d=matrix(0,ncol = N,nrow = nt),log_sd=rep(-1,2),
                  tau=55,c=1,ch=1)
random = c("a0","d0","a","d")

obj <- MakeADFun(data=data,parameters=parameters,random = random,DLL = "FullModel", silent = TRUE)
resP <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
repP = sdreport(obj)
repP

d = 2*(resP$value-resGP$value)
1-pchisq(d,1)#p-value for all seasons at the same time, this is not significant with alpha = 0.05

#the odds and probabilities 
probs = timeGPtoProbs(PL,M)
plotOddsLog(odds,probs,results,season = paste0(substring(sesong,1,2),"/",substring(sesong,3,4)),model = "Generalized Poisson GLMM")





